using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using MeshVR;
using SimpleJSON;
using UnityEngine.PostProcessing;
using UnityEngine.Rendering;
namespace SSSSkin_HuntingSuccubus
{
    public class SSSSkin_HuntingSuccubus : MVRScript
    {	DAZSkinV2 skin;
        JSONStorableFloat alpha;
        JSONStorableFloat downscale;		
        JSONStorableFloat blurIterations;		
        JSONStorableFloat scatterDistance;		
        JSONStorableFloat scatterIntensity;
        JSONStorableFloat softDepthBias;
        JSONStorableFloat affectDirect;
        int downscaleval;		
        int blurIterationsval;		
        float scatterDistanceval;		
        float scatterIntensityval;
        float softDepthBiasval;
        float affectDirectval;	
		
        JSONStorableBool enableSSS;
        JSONStorableUrl loadedShaderPath = new JSONStorableUrl("shader", "");
		bool nowStarted = false;
		bool directionalLightFound = false;
        bool loadedAssetBundle;
        bool isLoading;
        int retryAttempts;
		static int scatteringColorID;

        private static readonly string BUNDLE_NAME = "SSSSkinHuntSucMod.assetbundle";

        protected List<Material[]> ourMaterials = new List<Material[]>();
		public Material test;
        protected Shader shader;
		protected Shader sssshader;
		protected Shader maskShader;
		protected Shader copyDepthShader;
		protected Shader sssshader2;
		protected Shader maskShader2;
		protected Shader copyDepthShader2;
		
		public	Material maskmaterial;
		public	Material blurshadermaterial;
		public	Material copyDepthShadermaterial;
		public	Material maskmaterial2;
		public	Material blurshadermaterial2;
		public	Material copyDepthShadermaterial2;	
		Material[] sss1Materials;
		Material[] sss2Materials;
		Material[] sss3Materials;
		
		public Camera cam;	
			
        protected JSONStorableColor color;

		CommandBuffer buffer;
		CameraEvent camEvent = CameraEvent.BeforeImageEffectsOpaque;

        public override void Init()
        {
            try {				
                enableSSS = new JSONStorableBool("Enable Subsurface Scattering", true);
                RegisterBool(enableSSS);
                CreateToggle(enableSSS, false);
				
                color = new JSONStorableColor("Subdermal Scatter Color", HSVColorPicker.RGBToHSV(1f, 0.5f, 0.5f));
                RegisterColor(color);
                CreateColorPicker(color, false);
				
				downscale = new JSONStorableFloat("Resolution Downscale", 2f, 1f, 4f, true, true);
				RegisterFloat(downscale);
				CreateSlider(downscale, true);
				
				blurIterations = new JSONStorableFloat("Blur Iterations", 3f, 0f, 6f, true, true);
				RegisterFloat(blurIterations);
				CreateSlider(blurIterations, true);				
				
				scatterDistance = new JSONStorableFloat("Scatter Distance", 0.051f, 0f, 0.1f, true, true);
				RegisterFloat(scatterDistance);
				CreateSlider(scatterDistance, true);				
				
				scatterIntensity = new JSONStorableFloat("Scatter Intensity", 3f, 0f, 5f, true, true);
				RegisterFloat(scatterIntensity);
				CreateSlider(scatterIntensity, true);				
				
				softDepthBias = new JSONStorableFloat("Soft Depth Bias", 0.001f, 0f, 0.002f, true, true);
				RegisterFloat(softDepthBias);
				CreateSlider(softDepthBias, true);				
				
				affectDirect = new JSONStorableFloat("Color Affect Direct", 0.2f, 0f, 2f, true, true);
				RegisterFloat(affectDirect);
				CreateSlider(affectDirect, true);				

				StartCoroutine(LoadShaderAndInit());
				
				ApplyBuffer();
				skin = SuperController.singleton.GetSelectedAtom().GetComponentInChildren<DAZCharacterSelector>().selectedCharacter.skin;
                }
             catch (Exception e) {
                SuperController.LogError("Exception caught: " + e);
            }
        }
		
	void fixScalp()
	{var allWraps = containingAtom.gameObject.GetComponentsInChildren<DAZSkinWrap>(false);
		foreach (var wrap in allWraps) 
		{if (wrap.ToString().Contains("Scalp")) 
			{wrap.GPUmaterials[0].renderQueue = 2504;}					   
		}
	}
		
	void nowStart()
	{	
		sss1Materials = new Material[skin.GPUmaterials.Length];
		sss2Materials = new Material[skin.GPUmaterials.Length];
		sss3Materials = new Material[skin.GPUmaterials.Length];	
		for(int i = 0; i < skin.GPUmaterials.Length; i++)
		{
		var tempMat1 = new Material(maskShader2);
			tempMat1.SetColor("ScatteringColor", Color.red);
		var tempMat2 = new Material(copyDepthShader);
		var tempMat3 = new Material(sssshader);
		sss1Materials[i] = tempMat1;
		sss2Materials[i] = tempMat2;
		sss3Materials[i] = tempMat3;
		}
		//fixScalp();
		nowStarted = true;
		
		foreach (Light light in FindObjectsOfType<Light>())
		{
		 if(light.type==LightType.Point)
			light.shadowBias = 0f;
		 if(light.type==LightType.Directional)
			{if(light.enabled)
			directionalLightFound = true;}
		}
		if(!directionalLightFound)
		SuperController.LogMessage("No enabled Directional Light foumd!!! SSS Skin require atleast one Directional Light to function.");
	}	
		
   void LateUpdate() // Updating Matterial Buffers
    {if (nowStarted)
	  {	buffer.Clear();
		if(enableSSS.val)
		{
		AddMakeSSSMaskCommands(buffer);
		
		int blurRT1 = Shader.PropertyToID("_CPSSSSSBlur1");
		int blurRT2 = Shader.PropertyToID("_CPSSSSSBlur2");
		int src = Shader.PropertyToID("_CPSSSSSSource");
		int w = -1;
		int h = -1;
		Camera cam = Camera.main;
		if (cam != null)
		  {
			w = cam.pixelWidth / (int)downscale.val;
			h = cam.pixelHeight / (int)downscale.val;
		  }

		buffer.GetTemporaryRT(blurRT1, w, h, 16, FilterMode.Bilinear, RenderTextureFormat.ARGBFloat);
		buffer.GetTemporaryRT(blurRT2, w, h, 16, FilterMode.Bilinear, RenderTextureFormat.ARGBFloat);
		buffer.GetTemporaryRT(src, -1, -1, 24, FilterMode.Bilinear, RenderTextureFormat.ARGBFloat);
		buffer.SetGlobalFloat("_SoftDepthBias", softDepthBias.val * 0.05f * 0.2f);

		buffer.Blit(BuiltinRenderTextureType.CameraTarget, blurRT2);
		//buffer.Blit(BuiltinRenderTextureType.CurrentActive, sourceBuf);
		buffer.Blit(BuiltinRenderTextureType.CameraTarget, src);

		//multipass pass blur
		for (int k = 1; k <= (int)blurIterations.val; k++)
		{	buffer.SetGlobalFloat("_BlurStr", Mathf.Clamp01(scatterDistance.val * 0.08f - k * 0.022f * scatterDistance.val));
			buffer.SetGlobalVector("_BlurVec", new Vector4(1, 0, 0, 0));
			buffer.Blit(blurRT2, blurRT1, new Material(blurshadermaterial), 0);
			buffer.SetGlobalVector("_BlurVec", new Vector4(0, 1, 0, 0));
			buffer.Blit(blurRT1, blurRT2, new Material(blurshadermaterial), 0);

			buffer.SetGlobalVector("_BlurVec", new Vector4(1, 1, 0, 0).normalized);
			buffer.Blit(blurRT2, blurRT1, new Material(blurshadermaterial), 0);
			buffer.SetGlobalVector("_BlurVec", new Vector4(-1, 1, 0, 0).normalized);
			buffer.Blit(blurRT1, blurRT2, new Material(blurshadermaterial), 0);
			//SuperController.LogError("SCATTERDISTANCE="+scatterDistance);
		}
		//buffer.Blit(blurRT2, blurBuf);
		buffer.SetGlobalTexture("_BlurTex", blurRT2);
		buffer.SetGlobalFloat("_EffectStr", scatterIntensity.val);
		buffer.SetGlobalFloat("_PreserveOriginal", 1 - affectDirect.val);
		buffer.Blit(src, BuiltinRenderTextureType.CameraTarget, new Material(blurshadermaterial), 1);
		buffer.ReleaseTemporaryRT(blurRT1);
		buffer.ReleaseTemporaryRT(blurRT2);
		buffer.ReleaseTemporaryRT(src);
		}
	  }
	}
				
	public void AddMakeSSSMaskCommands(CommandBuffer buffer)
	{	int maskRT = Shader.PropertyToID("_MaskTex");
		buffer.GetTemporaryRT(maskRT, -1, -1, 24, FilterMode.Bilinear, RenderTextureFormat.ARGB32);
		buffer.Blit(BuiltinRenderTextureType.None, maskRT, new Material(copyDepthShadermaterial));
		buffer.SetRenderTarget(maskRT);	
		maskmaterial.SetColor("ScatteringColor", color.colorPicker.currentColor);
		for (int i = 0; i < skin.GPUmaterials.Length; i++)
		{if(skin.GPUmaterials[i].name == "Head" || skin.GPUmaterials[i].name == "Shoulders"||skin.GPUmaterials[i].name == "Neck" || skin.GPUmaterials[i].name == "Hips"||skin.GPUmaterials[i].name == "Torso" || skin.GPUmaterials[i].name == "Nipples"||skin.GPUmaterials[i].name == "Forearms"||skin.GPUmaterials[i].name == "Tongue"||skin.GPUmaterials[i].name == "Ears"||skin.GPUmaterials[i].name == "Legs"||skin.GPUmaterials[i].name == "Nostrils"||skin.GPUmaterials[i].name == "Lacrimals"||skin.GPUmaterials[i].name == "Lips"||skin.GPUmaterials[i].name == "Face"||skin.GPUmaterials[i].name == "Lacrimals"||skin.GPUmaterials[i].name == "Hands"||skin.GPUmaterials[i].name == "Legs"||skin.GPUmaterials[i].name == "defaultMat"||skin.GPUmaterials[i].name == "Head-1" || skin.GPUmaterials[i].name == "Shoulders-1"||skin.GPUmaterials[i].name == "Neck-1" || skin.GPUmaterials[i].name == "Hips-1"||skin.GPUmaterials[i].name == "Torso-1" || skin.GPUmaterials[i].name == "Nipples-1"||skin.GPUmaterials[i].name == "Forearms-1"||skin.GPUmaterials[i].name == "Tongue-1"||skin.GPUmaterials[i].name == "Ears-1"||skin.GPUmaterials[i].name == "Legs-1"||skin.GPUmaterials[i].name == "Nostrils-1"||skin.GPUmaterials[i].name == "Lacrimals-1"||skin.GPUmaterials[i].name == "Lips-1"||skin.GPUmaterials[i].name == "Face-1"||skin.GPUmaterials[i].name == "Lacrimals-1"||skin.GPUmaterials[i].name == "Hands-1"||skin.GPUmaterials[i].name == "Legs-1"||skin.GPUmaterials[i].name == "defaultMat-1")
			{
			skin.GPUmaterials[i].SetFloat("_Tess", 0f);
			sss1Materials[i].CopyPropertiesFromMaterial(skin.GPUmaterials[i]);
			sss1Materials[i].SetColor("ScatteringColor", color.colorPicker.currentColor);
			//sss1Materials[i].renderQueue = skin.GPUmaterials[i].renderQueue;
			buffer.DrawMesh(skin.Mesh,Matrix4x4.identity, sss1Materials[i], i);
			//if(sss1Materials[i].mainTexture == null) SuperController.LogError("mainTexture=null="+i);
			}
		}
		buffer.SetGlobalTexture("_MaskTex", maskRT);
	}	
	
	void ApplyBuffer()
	{
		buffer = new CommandBuffer();
		buffer.name = "Screen Space Subsurface Scattering";
		cam = CameraTarget.centerTarget?.targetCamera;
		//GetComponent<Camera>().AddCommandBuffer(camEvent, buffer);	
		cam.AddCommandBuffer(camEvent, buffer);	
	}		
		
	void CleanupBuffer()
	{
		if (buffer!=null)
		{
		buffer.Clear();
		cam.RemoveCommandBuffer(camEvent, buffer);
		buffer = null;
		}
	}	

	void OnEnable()
	{
			ApplyBuffer();
	}

	void OnDisable()
	{
			CleanupBuffer();
	}		




      















       		
		
		
		
		
		
		
		
		
		
		
		
		
//////////////////////  AssetLoader/////////////////////////////////////////
	
	
       class LoadAssetBundle : CustomYieldInstruction {
            AssetLoader.AssetBundleFromFileRequest req;
            private bool done;
            // We can't write the type AssetBundle, but we can call methods on it. lolwut C#
            public bool success => req.assetBundle != null;
            public T GetAsset<T>(string name) where T : UnityEngine.Object
            {
                return req.assetBundle?.LoadAsset<T>(name);
            }
            public LoadAssetBundle(string url)
            {
                req = new AssetLoader.AssetBundleFromFileRequest {
                    path = url,
                    callback = _ => {
                        done = true;
                        if (req.assetBundle == null)
                            AssetLoader.DoneWithAssetBundleFromFile(req.path);
                    }
                };
                AssetLoader.QueueLoadAssetBundleFromFile(req);
            }
            public override bool keepWaiting => !done;
        }
	        private IEnumerator AttemptLoadShader(string url)
        {
            if (shader != null)
                yield break;
            var request = new LoadAssetBundle(url);
            yield return StartCoroutine(request);
            if (!request.success)
                yield break;
            shader = request.GetAsset<Shader>("Assets/EmissiveHack.shader");
			sssshader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_SSSSS_Shader.shader");
            maskShader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_SSSSS_Mask.shader");			
            copyDepthShader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_SSSSS_BlitDepthTextureToDepth.shader");
            sssshader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/VAMCP_SSSSS_Shader.shader");
            maskShader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/VAMCP_SSSSS_Mask.shader");			
            copyDepthShader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/VAMCP_SSSSS_BlitDepthTextureToDepth.shader");	

			
			maskmaterial = new Material(maskShader);
			maskmaterial.SetColor("ScatteringColor", Color.red);
			blurshadermaterial = new Material(sssshader);
			copyDepthShadermaterial = new Material(copyDepthShader);
			maskmaterial2 = new Material(maskShader2);
			maskmaterial2.SetColor("ScatteringColor", Color.red);
			blurshadermaterial2 = new Material(sssshader);
			copyDepthShadermaterial2 = new Material(copyDepthShader2);
		
			
            if (shader != null) {
                loadedShaderPath.val = url;
                loadedAssetBundle = true;
            } else {
                SuperController.LogError("Not found location in emissiveshader assetbundle");
                AssetLoader.DoneWithAssetBundleFromFile(url);
            }
        }
		
		
        string GetPluginPath() // basically straight from VAMDeluxe's Dollmaster
        {
            string pluginId = this.storeId.Split('_')[0];
            string pathToScriptFile = manager.GetJSON(true, true)["plugins"][pluginId].Value;
            string pathToScriptFolder = pathToScriptFile.Substring(0, pathToScriptFile.LastIndexOfAny(new char[] { '/', '\\' }));
            return pathToScriptFolder;
        }		
		
	        protected IEnumerator LoadShaderAndInit()
        {
						//SuperController.LogMessage("main.LoadShaderAndInit");
            // Wait until json load is done
            yield return new WaitForEndOfFrame();

            if (shader == null) {
                if (loadedShaderPath.val != "")
                    yield return AttemptLoadShader(loadedShaderPath.val);
		//SuperController.LogError("path"+GetPluginPath());
                yield return AttemptLoadShader($"{GetPluginPath()}/{BUNDLE_NAME}");
                yield return AttemptLoadShader($"Custom/Scripts/Hunting-Succubus/{BUNDLE_NAME}");

                if (shader == null || maskShader == null || copyDepthShader == null) {
                    SuperController.LogError("main.Failed to load shader");
                    yield break;
                }
            }
			nowStart();
        }	
	
	       class EmissiveSkin : DAZSkinV2
		   {
			   
		   }
	
	
	
		
		
		
		
    }

}